# -*- coding:Utf-8 -*-
# dm_python V1.112p (02/10/2008) by DoCky


import psyco, os.path, cPickle, random, re, es, popuplib, playerlib, gamethread, effectlib
psyco.full()


class Cvar:
    """
        Convar management
    """

    def __init__(self):
        self._oldv = {}
        self._cvar = (
            (
                es.ServerVar("dm_python", "", "Created by DoCky -"),
                es.ServerVar("dp_langage", "", "[dm_python] script langage"),
                es.ServerVar("dp_killmax", "", "[dm_python] kill max"),
                es.ServerVar("dp_timeout", "", "[dm_python] menu timeout"),
                es.ServerVar("dp_mission", "", "[dm_python] remove objectif"),
                es.ServerVar("dp_steamid", "", "[dm_python] administrators list")
                ),

            (
                es.ServerVar("dp_player_nightvision", "", "[dm_python] give nightvision"),
                es.ServerVar("dp_player_defusekit", "", "[dm_python] give defuse kit"),
                es.ServerVar("dp_player_hegrenade", "", "[dm_python] grenade max"),
                es.ServerVar("dp_player_flashbang", "", "[dm_python] flashbang max"),
                es.ServerVar("dp_player_smokegrenade", "", "[dm_python] smokegrenade max"),

                es.ServerVar("dp_bot_primary", "", "[dm_python] bot primary weapon"),
                es.ServerVar("dp_bot_secondary", "", "[dm_python] bot secodary weapon"),
                es.ServerVar("dp_bot_nightvision", "", "[dm_python] give bot nightvision"),
                es.ServerVar("dp_bot_defusekit", "", "[dm_python] give bot defuse kit"),
                es.ServerVar("dp_bot_hegrenade", "", "[dm_python] bot grenade max"),
                es.ServerVar("dp_bot_flashbang", "", "[dm_python] bot flashbang max"),
                es.ServerVar("dp_bot_smokegrenade", "", "[dm_python] bot smokegrenade max")
                )
            )

        self._cvar[0][0].set(dp_info.version)
        self._cvar[0][0].makepublic()

    def __newv(self):
        es.forcevalue("mp_timelimit", 0)
        es.forcevalue("mp_fraglimit", self._cvar[0][2])

    def load(self):
        self._oldv = {
            "mp_fraglimit" : int(es.server_var["mp_fraglimit"]),
            "mp_timelimit" : int(es.server_var["mp_timelimit"])
            }
        gamethread.delayed(1, self.__newv)     

    def unload(self):
        for cvar in self._oldv: es.forcevalue(cvar, self._oldv[cvar])


class File:
    """
        File reader
    """

    def __init__(self):
        self._line = []

    def __loop(self):
        indx = 0
        while indx < len(self._line):
            self._line[indx] = re.sub('//.*|^(( |\t)+)|(( |\t)+)$|(\r)+|(\t)+|(\n)+|(")+|', "", self._line[indx])
            if not self._line[indx]: del(self._line[indx])
            else: indx += 1

    def read(self, P):
        try:
            self._line, line = [], open(P, "r")
            self._line = line.readlines()
            line.close(), self.__loop()
            return self._line[:]

        except:
            es.dbgmsg(0, "[dm_python] Can't load file : %s" % P)


class Lang:
    """
        Script language
    """

    def __init__(self):
        self._lang = {}

    def script(self):
        for line in _file.read("%s/language/%s.txt" % (dp_path, _cvar._cvar[0][1])):
            item = line.split("=")
            if len(item) == 2: self._lang[item[0].strip()] = item[1].strip()


class Maps:
    """
        Map management
    """

    def __init__(self):
        self._path = es.getAddonPath(dp_info.name) + "/dm_data/spawn.dp"
        self._name = es.ServerVar("eventscripts_currentmap")
        self._data = {}

    def save(self):
        cPickle.dump(self._data, open(self._path, "w"))

    def load(self):
        if not os.path.isfile(self._path):
            self.save()
        self._data = cPickle.load(open(self._path, "r"))

        if not str(self._name) in self._data:
            self._data[str(self._name)] = []

    def random(self, I):
        maxi = len(self._data[str(self._name)])
        if maxi >= es.getmaxplayercount(): self.setpos(I, random.randint(0, maxi - 1))

    def setpos(self, I, S):
        vect = self._data[str(self._name)][S]
        es.server.queuecmd("es_xsetpos %s %s %s %s" % (I, vect[0][0], vect[0][1], vect[0][2]))
        es.server.queuecmd("es_xsetang %s %s %s %s" % (I, vect[1][0], vect[1][1], vect[1][2]))

    def remove(self, I):
        if I < len(self._data[str(self._name)]): del(self._data[str(self._name)][I])

    def append(self, I):
        eye1 = es.getplayerprop(I, "CCSPlayer.m_angEyeAngles[1]")
        if eye1 < 0: eye1 += 360
        self._data[str(self._name)].append(
            (
                es.getplayerlocation(I),
                (
                    es.getplayerprop(I, "CCSPlayer.m_angEyeAngles[0]"),
                    eye1,
                    float(es.getplayerprop(I, "CBaseEntity.m_angRotation")[2])
                    )
                )
            )

    def effect(self, C, I):
        if I < len(self._data[str(self._name)]):
            loc1 = map(lambda x: float(x), self._data[str(self._name)][I][0])
            loc2 = loc1[:]
            loc1[0] -= 30
            loc1[1] += 30
            loc2[0] += 30
            loc2[1] -= 30
            loc2[2] += 100

            if not C: effectlib.drawBox(loc1, loc2, seconds = 1, green = 0, blue = 0)
            elif C == 1: effectlib.drawBox(loc1, loc2, seconds = 1, red = 0, blue = 0)
            else:effectlib.drawBox(loc1, loc2, seconds = 1)


class Menu:
    """
        Deathmatch menu
    """

    def __init__(self):
        if not es.exists("clientcommand", "!dm"):
            es.regclientcmd("!dm", "dm_python/player_cmd", "dm_python menu acces")
        self._adms, self._user = Menu.Admin(), Menu.Player()

    def load(self):
        self._adms.create(), self._user.create()

    def send(self, U, I):
        name = popuplib.active(I)["name"]
        if name != "0" and "dp_" in name: popuplib.close(name, I)
        if U in self._adms._user: popuplib.send("dp_dpa", I)
        else: popuplib.send("dp_dpm", I)

    def unload(self):
        if es.exists("clientcommand", "!dm"): es.unregclientcmd("!dm")
        for user in playerlib.getUseridList("#human"):
            name = popuplib.active(user)["name"]
            if "dp_" in name: popuplib.unsendname(name, user)

        for menu in self._user._menu.keys(): popuplib.delete(menu)
        for menu in ("dp_dpm", "dp_spn", "dp_dpa", "dp_arm"): popuplib.delete(menu)


    class Admin:
        """
            Administrator menu
        """

        def __init__(self):
            self._user = []
            self._menu = {}
            self._indx = 0

        def __indx(self, M, I):
            if I:
                M.modline(2, "N° spawnpoint : %s" % I)
            else:
                M.modline(2, "N° spawnpoint : no created")

        def __clip(self, M, I):
            if es.getplayerprop(I, "CBaseEntity.movetype") == 8:
                M.modline(3, "1. %s" % _lang._lang["dm_admin_clip"].replace("%1", "On"))
            else:
                M.modline(3, "1. %s" % _lang._lang["dm_admin_clip"].replace("%1", "Off"))

        def __func(self, M, I):
            if len(_maps._data[str(_maps._name)]):
                M.modline(6, "->3. %s" % _lang._lang["dm_admin_remo"])
                M.modline(7, "->4. %s" % _lang._lang["dm_admin_last"])
                M.modline(8, "->5. %s" % _lang._lang["dm_admin_next"])
            else:
                M.modline(6, "3. %s" % _lang._lang["dm_admin_remo"])
                M.modline(7, "4. %s" % _lang._lang["dm_admin_last"])
                M.modline(8, "5. %s" % _lang._lang["dm_admin_next"])

        def __user(self, I, C, N):
            if C < 6:
                menu = popuplib.find(N)
                numb = len(_maps._data[str(_maps._name)])

                if C == 1:
                    if es.getplayerprop(I, "CBaseEntity.movetype") == 8:
                        es.setplayerprop(I, "CBaseEntity.movetype", 2)
                    else:
                        es.setplayerprop(I, "CBaseEntity.movetype", 8)
                    self.__clip(menu, I)

                elif C == 2:
                    _maps.append(I)
                    numb = len(_maps._data[str(_maps._name)])
                    self._menu[I] = [numb, numb - 1]
                    _maps.effect(1, numb - 1)
                else:

                    if not numb:
                        self._menu[I] = [0, -1]
                    else:
                        if C == 3:
                            _maps.effect(0, self._menu[I][1])
                            _maps.remove(self._menu[I][1])
                            numb = len(_maps._data[str(_maps._name)])

                            if not numb:self._menu[I] = [0, -1]
                            else:
                                if self._menu[I][1] - 1 < 0:self._menu[I] = [numb, numb - 1]
                                else:self._menu[I][1] -= 1

                        elif C == 4:
                            if self._menu[I][1] - 1 < 0: self._menu[I][1] = numb
                            self._menu[I][1] -= 1
                            _maps.setpos(I, self._menu[I][1])
                            _maps.effect(2, self._menu[I][1])

                        elif C == 5:
                            if self._menu[I][1] == numb - 1: self._menu[I] = [numb, -1]
                            self._menu[I][1] += 1
                            _maps.setpos(I, self._menu[I][1])
                            _maps.effect(2, self._menu[I][1])

                self.__indx(menu, self._menu[I][1] + 1)
                self.__func(menu, I)
                menu.send(I)

        def __menu(self, I, C, N):
            if C == 2:
                _user.arms(es.getplayersteamid(I), I)

            elif C == 3:
                menu = popuplib.find("dp_spn")
                numb = len(_maps._data[str(_maps._name)])
                self._menu[I] = [numb, numb - 1]
                self.__clip(menu, I)
                self.__func(menu, I)
                self.__indx(menu, numb)
                menu.send(I)

        def create(self):
            self._user = map(lambda x: x.strip(), str(_cvar._cvar[0][5]).split(","))
            A = popuplib.create("dp_dpa")
            if int(_cvar._cvar[0][3]): A.timeout("view", _cvar._cvar[0][3])
            A.addline(_lang._lang["dm_title_dmmenu"])
            A.addline("->1. %s" % _lang._lang["dm_option_arms"])
            A.addline("->2. %s" % _lang._lang["dm_option_save"])
            A.addline("->3. %s" % _lang._lang["dm_option_user"])
            if _lang._lang["dm_admin_menucmd"] != "0": A.addline(_lang._lang["dm_admin_menucmd"])
            A.addline("0. %s" % _lang._lang["dm_option_exit"])
            A.submenu(1, "dp_arm")
            A.submenu(2, "dp_dpa")
            A.menuselect = self.__menu

            A = popuplib.create("dp_spn")
            A.addline(_lang._lang["dm_admin_title"])
            A.addline("N° spawnpoint : ")
            A.addline(" ")
            A.addline(" ")
            A.addline("->2. %s" % _lang._lang["dm_admin_save"])
            A.addline(" ")
            A.addline(" ")
            A.addline(" ")
            A.addline(" ")
            A.addline("9. %s" % _lang._lang["dm_option_back"])
            A.addline("0. %s" % _lang._lang["dm_option_exit"])
            A.submenu(9, "dp_dpa")
            A.menuselect = self.__user

    class Player:
        """
            Player menu
        """

        def __init__(self):
            self._menu = {}

        def __save(self, I, C, N):
            if C == 2:
                _user.arms(es.getplayersteamid(I), I)

        def __sect(self, I, C, N):
            if C == 9:
                if es.getplayersteamid(I) in _menu._adms._user:
                    popuplib.send("dp_dpa", I)
                else:
                    popuplib.send("dp_dpm", I)

        def __give(self, I, C, N):
            if C in self._menu[N]:
                unid = es.getplayersteamid(I)
                if N == "dp_gun":
                    _user._data[unid][1] = self._menu[N][C]
                    _user.give(unid, I, 0, 1)

                else:
                    _user._data[unid][0] = self._menu[N][C]
                    _user.give(unid, I, 1, 0)

                if _lang._lang["dm_message_savearm"] != "0":
                    es.tell(I, "#multi", _lang._lang["dm_message_savearm"].replace("%1", _user._data[unid][1]).replace("%2", _user._data[unid][0]))

        def create(self):
            arms = {
                "gun" : ["glock", "usp", "p228", "deagle", "fiveseven", "elite"],
                "pmp" : ["m3", "xm1014"],
                "pms" : ["tmp", "mac10", "mp5navy", "ump45", "p90"],
                "rif" : ["galil", "famas", "ak47", "m4a1", "sg552", "aug", "m249"],
                "snp" : ["scout", "awp", "g3sg1", "sg550"]
                }

            for sect, item in arms.items():
                I = 0
                while I != len(item):
                    if item[I] in _rest: del(item[I])
                    else: I += 1

            M = popuplib.create("dp_dpm")
            if int(_cvar._cvar[0][3]): M.timeout("view", _cvar._cvar[0][3])
            M.addline(_lang._lang["dm_title_dmmenu"])
            M.addline("->1. %s" % _lang._lang["dm_option_arms"])
            M.addline("->2. %s" % _lang._lang["dm_option_save"])
            if _lang._lang["dm_title_menucmd"] != "0": M.addline(_lang._lang["dm_title_menucmd"])
            M.addline("0. %s" % _lang._lang["dm_option_exit"])
            M.submenu(1, "dp_arm")
            M.submenu(2, "dp_dpm")
            M.menuselect = self.__save

            M = popuplib.create("dp_arm")
            if int(_cvar._cvar[0][3]): M.timeout("view", _cvar._cvar[0][3])
            M.addline(_lang._lang["dm_title_section"])
            M.menuselect = self.__sect
            S = 0

            for sect in ("gun", "pmp", "pms", "rif", "snp"):
                if len(arms[sect]):
                    I = 0
                    S += 1

                    M.addline("->%s. %s" % (S, _lang._lang["dm_weapon_%s" % sect]))
                    self._menu["dp_%s" % sect] = {}
                    M.submenu(S, "dp_%s" % sect)
                    W = popuplib.create("dp_%s" % sect)
                    if int(_cvar._cvar[0][3]): W.timeout("view", _cvar._cvar[0][3])
                    W.addline(_lang._lang["dm_weapon_%s" % sect])

                    while I != len(arms[sect]):
                        I += 1
                        W.addline("->%s. %s" % (I, arms[sect][I - 1]))
                        W.submenu(I, "dp_arm")
                        self._menu["dp_%s" % sect][I] = arms[sect][I - 1]

                    W.addline("9. %s" % _lang._lang["dm_option_back"])
                    W.addline("0. %s" % _lang._lang["dm_option_exit"])
                    W.submenu(9, "dp_arm")
                    W.menuselect = self.__give
            M.addline("9. %s" % _lang._lang["dm_option_back"])
            M.addline("0. %s" % _lang._lang["dm_option_exit"])


class User:
    """
        Player management
    """

    def __init__(self):
        self._path = es.getAddonPath(dp_info.name) + "/dm_data/data.dp"
        self._data = {}

    def save(self):
        cPickle.dump(self._data, open(self._path, "w"))

    def load(self):
        if not os.path.isfile(self._path): self.save()
        self._data = cPickle.load(open(self._path, "r"))

    def data(self, U):
        if not self._data.has_key(U): self._data[U] = ["m4a1", "deagle"]

    def arms(self, U, I):
        user = playerlib.getPlayer(I)
        self._data[U] = [user.get("primary"), user.get("secondary")]

        if _lang._lang["dm_message_savearm"] != "0":
            es.tell(I, "#multi", _lang._lang["dm_message_savearm"].replace("%1", _user._data[U][1]).replace("%2", _user._data[U][0]))

    def give(self, U, I, P, S):
        user = playerlib.getPlayer(I)
        if P and self._data[U][0] != "0":
            name = user.get("primary")
            if name != self._data[U][0]:
                if name != "0": es.server.queuecmd("es_xremove %s" % user.get("weaponindex", name))
                es.server.queuecmd("es_xgive %s weapon_%s" % (I, self._data[U][0]))

        if S and self._data[U][1] != "0":
            name = user.get("secondary")
            if name != self._data[U][1]:
                if name != "0": es.server.queuecmd("es_xremove %s" % user.get("weaponindex", name))
                es.server.queuecmd("es_xgive %s weapon_%s" % (I, self._data[U][1]))

    def spawn(self, I, U, T):
        es.server.queuecmd("es_xgive %s item_assaultsuit" % I)
        es.setplayerprop(I, "CBasePlayer.m_lifeState", 0)
        es.setplayerprop(I, "CBaseEntity.m_CollisionGroup", 2)
        gamethread.delayed(1.5, es.setplayerprop, (I, "CBasePlayer.m_lifeState", 512))
        gamethread.delayed(2, es.setplayerprop, (I, "CBaseEntity.m_CollisionGroup", 5))

        if int(_cvar._cvar[1][0]): es.setplayerprop(I, "CCSPlayer.m_bHasNightVision", 1)
        if int(_cvar._cvar[1][1]) and T == "3": es.setplayerprop(I, "CCSPlayer.m_bHasDefuser", 1)
        self.give(U, I, 1, 1), _nade.user(I)
        for nade in (0, 1, 2): _nade.give(I, nade)


class Bots:
    """
        Bots management
    """

    def item(self):
        self._item = [
            ["m3", "xm1014",
            "tmp", "mac10", "mp5navy", "ump45", "p90",
            "galil", "famas", "ak47", "m4a1", "sg552", "aug", "m249",
            "scout", "awp", "g3sg1", "sg550"],
            ["glock", "usp", "p228", "deagle", "fiveseven", "elite"]
            ]

        for item in self._item:
            indx = 0
            while indx != len(item):
                if item[indx] in _rest: del(item[indx])
                else: indx += 1

        if str(_cvar._cvar[1][5]) and _cvar._cvar[1][5] != "0":
            self._item[0] = [a for a in str(_cvar._cvar[1][5]).split(",") if a.strip() in self._item[0]]
        if str(_cvar._cvar[1][6]) and _cvar._cvar[1][6] != "0":
            self._item[1] = [a for a in str(_cvar._cvar[1][5]).split(",") if a.strip() in self._item[1]]

    def give(self, I):
        user = playerlib.getPlayer(I)
        name, rand = user.get("primary"), random.choice(self._item[0])
        if name != rand:
            if name != "0": es.server.queuecmd("es_xremove %s" % user.get("weaponindex", name))
            es.server.queuecmd("es_xgive %s weapon_%s" % (I, rand))

        name, rand = user.get("secondary"), random.choice(self._item[1])
        if name != rand:
            if name != "0": es.server.queuecmd("es_xremove %s" % user.get("weaponindex", name))
            es.server.queuecmd("es_xgive %s weapon_%s" % (I, rand))

    def spawn(self, I, T):
        es.server.queuecmd("es_xgive %s item_assaultsuit" % I)
        es.setplayerprop(I, "CBasePlayer.m_lifeState", 0)
        es.setplayerprop(I, "CBaseEntity.m_CollisionGroup", 2)
        gamethread.delayed(1.5, es.setplayerprop, (I, "CBasePlayer.m_lifeState", 512))
        gamethread.delayed(2, es.setplayerprop, (I, "CBaseEntity.m_CollisionGroup", 5))

        if int(_cvar._cvar[1][7]): es.setplayerprop(I, "CCSPlayer.m_bHasNightVision", 1)
        if int(_cvar._cvar[1][8]) and T == "3": es.setplayerprop(I, "CCSPlayer.m_bHasDefuser", 1)
        self.give(I), _nade.user(I)
        for nade in (0, 1, 2): _nade.give(I, nade)


class Nade:
    """
        Grenade management
    """

    def __init__(self):
        self._user = {}

    def user(self, I):
        if es.isbot(I): self._user[I] = [int(_cvar._cvar[1][9]), int(_cvar._cvar[1][10]), int(_cvar._cvar[1][11])]
        else: self._user[I] = [int(_cvar._cvar[1][2]), int(_cvar._cvar[1][3]), int(_cvar._cvar[1][4])]

    def give(self, I, N):
        if not N:
            if self._user[I][0] > 0:
                if not playerlib.getPlayer(I).get("he"):
                    self._user[I][0] -= 1
                    es.server.queuecmd("es_xgive %s weapon_hegrenade" % I)

        elif N == 1:
            if self._user[I][1] > 0:
                if not playerlib.getPlayer(I).get("fb"):
                    self._user[I][1] -= 1
                    es.server.queuecmd("es_xgive %s weapon_flashbang" % I)

        elif N == 2:
            if self._user[I][2] > 0:
                if not playerlib.getPlayer(I).get("sg"):
                    self._user[I][2] -= 1
                    es.server.queuecmd("es_xgive %s weapon_smokegrenade" % I)


dp_info = es.AddonInfo()
dp_info.version = "1.112p"
dp_info.author = "DoCky"
dp_info.name = "dm_python"
dp_info.url = "http://addons.eventscripts.com/addons/user/11751"
dp_path = es.ServerVar("eventscripts_gamedir") + "/cfg/dm_python/"
_cvar, _file, _lang, _maps, _menu, _user = Cvar(), File(), Lang(), Maps(), Menu(), User()


def init():
    es.server.cmd("es_xmexec dm_python/config.cfg")
    es.server.cmd("es_xmexec dm_python/items.txt")

    global _rest, _bots, _nade, _remo, _maxi
    _bots, _nade, _maxi, _remo = Bots(), Nade(), es.getmaxplayercount(), 0

    _rest = _file.read(dp_path + "restrict.txt")
    _lang.script(), _cvar.load(), _maps.load(), _menu.load(), _user.load(), _bots.item(), remove_entity()
    es.log("[dm_python] is ON.")

    for user in playerlib.getUseridList("#alive"):
        if es.isbot(user): _bots.spawn(user, es.getplayerteam(user))
        else:
            unid = es.getplayersteamid(user)
            if unid != "STEAM_ID_PENDING": player_chk(unid, user)

def remove_entity():
    global _remo
    if _remo > 11:
        _remo = 0
        enti = [i for i, a in es.createentitylist().items() if a["classname"].startswith("weapon_") and es.getindexprop(i, "CBaseCombatWeapon.m_hOwner") == -1 or a["classname"] == "cs_ragdoll"]
        for indx in enti: es.server.queuecmd("es_xremove %s" % indx)
    else: _remo += 1

def unload():
    _cvar.unload()
    _menu.unload()
    _maps.save()
    _user.save()
    es.log("[dm_python] is OFF.")

def load():
    init()

def es_map_start(E):
    _maps.save()
    _user.save()
    init()

def round_start(E):
    if not int(_cvar._cvar[0][4]):
        es.server.queuecmd("es_xremove weapon_c4")
        (lambda x: es.server.queuecmd("es_xremove %s" % x)) (es.createentitylist("hostage_entity"))

def player_cmd():
    user = es.getcmduserid()
    player_chk(es.getplayersteamid(user), user)

def player_say(E):
    if E["text"] == "!dm": player_chk(E["es_steamid"], E["userid"])

def player_chk(U, I):
    if U == "STEAM_ID_PENDING":
        if _lang._lang["dm_message_errordm"] != "0":
            es.tell(I, "#multi", _lang._lang["dm_message_errordm"])
    else:
        if es.getplayerprop(I, "CBasePlayer.pl.deadflag"): es.server.queuecmd("est_spawn %s" % I)
        if U != "BOT":
            _user.data(U)
            _menu.send(U, I)

def player_death(E):
    remove_entity(), gamethread.delayed(1.5, es.server.queuecmd, "est_spawn %s" % E["userid"]), gamethread.delayed(1.5, _maps.random, E["userid"])
    if _lang._lang["dm_message_respawn"] != "0": es.tell(E["userid"], "#multi", _lang._lang["dm_message_respawn"])

def player_spawn(E):
    if not es.getplayerprop(E["userid"], "CBasePlayer.pl.deadflag") and E["es_steamid"] != "STEAM_ID_PENDING":
        if E["es_steamid"] == "BOT": _bots.spawn(E["userid"], E["es_userteam"])
        elif _user._data.has_key(E["es_steamid"]):
            _user.spawn(E["userid"], E["es_steamid"], E["es_userteam"])
            _maps.random(E["userid"])

    elif _lang._lang["dm_message_maxkill"] != "0":
        es.tell(E["userid"], "#multi", _lang._lang["dm_message_maxkill"].replace("%1", str(_cvar._cvar[0][2])))

def es_player_validated(E):
    if not _user._data.has_key(E["networkid"]): _user.data(E["networkid"])

def player_team(E):
    unid = es.getplayersteamid(E["userid"])
    if unid != "BOT" and unid != "STEAM_ID_PENDING" and E["disconnect"] == "0":
        if not _user._data.has_key(unid): _user.data(E["networkid"])
        if int(E["team"]) > 1: gamethread.delayed(2, player_chk, (unid, E["userid"]))

def item_pickup(E):
    if E["item"] in _rest:
        es.server.queuecmd("es_xremove %s" % playerlib.getPlayer(E["userid"]).get("weaponindex", E["item"]))
        es.sexec(E["userid"], "use weapon_knife")

def hegrenade_detonate(E):
    _nade.give(E["userid"], 0)

def flashbang_detonate(E):
    _nade.give(E["userid"], 1)

def smokegrenade_detonate(E):
    _nade.give(E["userid"], 2)
